<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects;

use InvalidArgumentException;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\HodnotenieEmisnejKontrolyEnum;

/**
 * Class PocetKontrolPodlaHodnotenia
 *
 * @package Seka\Portal\Modul\Statistiky\Models\Zaznam\ValueObjects
 */
final class PocetKontrolPodlaHodnotenia implements PocetKontrol
{
    /**
     * @var \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\HodnotenieEmisnejKontrolyEnum
     */
    private HodnotenieEmisnejKontrolyEnum $hodnotenie;

    /**
     * @var int
     */
    private int $pocet;

    /**
     * PocetKontrolPodlaHodnotenia constructor.
     *
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\HodnotenieEmisnejKontrolyEnum $hodnotenie
     * @param int                                                                               $pocet
     */
    public function __construct(HodnotenieEmisnejKontrolyEnum $hodnotenie, int $pocet)
    {
        $this->hodnotenie = $hodnotenie;
        $this->pocet = $pocet;
    }

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaHodnotenia $pocetKontrolPodlaHodnotenia
     *
     * @return $this
     */
    public function navysitPocet(self $pocetKontrolPodlaHodnotenia): self
    {
        if (false === $pocetKontrolPodlaHodnotenia->hodnotenie->equal($this->hodnotenie)) {
            throw new InvalidArgumentException('Navysenie poctu kontrol podla ineho hodnotenia kontroly nie je mozne.');
        }

        return new self(
            $this->hodnotenie,
            $this->pocet + $pocetKontrolPodlaHodnotenia->pocet()
        );
    }

    /**
     * @return int
     */
    public function pocet(): int
    {
        return $this->pocet;
    }

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaHodnotenia $pocetKontrolPodlaHodnotenia
     *
     * @return bool
     */
    public function equalsHodnotenie(self $pocetKontrolPodlaHodnotenia): bool
    {
        return $this->hodnotenie()->equal($pocetKontrolPodlaHodnotenia->hodnotenie());
    }

    /**
     * @return \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\HodnotenieEmisnejKontrolyEnum
     */
    public function hodnotenie(): HodnotenieEmisnejKontrolyEnum
    {
        return $this->hodnotenie;
    }

    /**
     * @return string
     */
    public function jsonSerialize(): string
    {
        return json_encode($this->toArray());
    }

    /**
     * @return array
     */
    public function toArray(): array
    {
        return [
            'hodnotenie' => $this->hodnotenie->value,
            'pocet' => $this->pocet,
        ];
    }
}
